/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao;

import java.util.Collection;

import org.appspy.server.bo.Application;
import org.appspy.server.bo.ApplicationVersion;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface ApplicationDao {

	public Application saveApplication(Application application);

	public Application updateApplication(Application application);

	public void removeApplication(Application application);
	
	public Application findApplicationById(Long applicationId);
	
	public Application findApplicationByCode(String code);

	public Collection<Application> findAllApplications();
	
	public ApplicationVersion saveVersion(ApplicationVersion version);

	public ApplicationVersion updateVersion(ApplicationVersion version);

	public ApplicationVersion findVersionById(Long versionId);
	
	public ApplicationVersion findVersionByName(Application application, String versionName);

	public void removeVersion(ApplicationVersion version);

	public Collection<ApplicationVersion> findAllVersions();

	public ApplicationVersion findOrCreateVersion(String appCode, String versionName);
}
