/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao;

import java.util.Collection;

import org.appspy.server.bo.Environment;
import org.appspy.server.bo.Host;
import org.appspy.server.bo.Organization;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface EnvironmentDao {

	public Environment findOrCreateEnvironment(String orgCode, String envCode);

	public Organization saveOrganization(Organization organization);

	public Organization updateOrganization(Organization organization);
	
	public void deleteOrganization(Organization organization);

	public Organization findOrganizationByCode(final String orgCode);

	public Organization findOrganizationById(Long orgId);

	public Collection<Organization> findAllOrganizations();

	public Host saveHost(Host host);

	public Host updateHost(Host host);
	
	public void deleteHost(Host host);

	public Host findHostByName(final String hostName);

	public Host findHostById(Long hostId);
	
	public Host findOrCreateHost(String hostName);

	public Collection<Host> findAllHosts(boolean fetchEnvironments);

	public Collection<Host> getHosts(Environment env);

	public Environment saveEnvironment(Environment env);

	public Environment updateEnvironment(Environment env);
	
	public void deleteEnvironment(Environment env);

	public Environment findEnvironmentByCode(final Organization org, final String envCode);

	public Environment findEnvironmentById(Long envId);

	public Collection<Environment> findAllEnvironments(boolean fetchHosts);

}
