/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao;

import java.util.Collection;
import java.util.Date;

import org.appspy.server.bo.scheduler.JobDeclaration;
import org.appspy.server.bo.scheduler.JobExecution;
import org.appspy.server.bo.scheduler.JobSchedule;


/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface SchedulerDao {
	
	public JobDeclaration createJobDeclaration(JobDeclaration jobDeclaration);
	
	public JobDeclaration updateJobDeclaration(JobDeclaration jobDeclaration);
	
	public void removeJobDeclaration(JobDeclaration jobDeclaration);
	
	public JobDeclaration findJobDeclarationById(Long id);
	
	public Collection<JobDeclaration> getAllJobDeclarations();
	
	public JobSchedule createJobSchedule(JobSchedule jobSchedule);
	
	public JobSchedule updateJobSchedule(JobSchedule jobSchedule);
	
	public void removeJobSchedule(JobSchedule jobSchedule);
	
	public JobSchedule findJobScheduleById(Long id);
	
	public Collection<JobSchedule> findAllJobSchedules();
	
	public JobExecution createJobExecution(JobExecution jobExecution);
	
	public JobExecution updateJobExecution(JobExecution jobExecution);
	
	public void removeJobExecution(JobExecution jobExecution);
	
	public JobExecution findJobExecutionById(Long id);
	
	public Collection<JobExecution> findAllJobExecutions();
	
	public void removeJobExecutionsByDate(final Date date);
}
