/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao.xml;

import java.util.ArrayList;

import org.appspy.server.xml.XmlDashboard;
import org.appspy.server.xml.XmlDashboardColumn;
import org.appspy.server.xml.XmlDashboardParamBinding;
import org.appspy.server.xml.XmlDashboardReport;
import org.appspy.server.xml.XmlReport;
import org.appspy.server.xml.XmlReportParam;
import org.appspy.server.xml.XmlReportingSystem;

import com.thoughtworks.xstream.XStream;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class XStreamLoader {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		XStream x = new XStream();

		ArrayList<Object> datas = new ArrayList<Object>();

		XmlReportingSystem xrs = new XmlReportingSystem();
		xrs.setName("BIRT");
		xrs.setHandler("org.appspy.BirtReportingSystemHandler");
		
		datas.add(xrs);
		
		XmlReport xr = new XmlReport();
		xr.setName("reportName");
		XmlReportParam xrp = new XmlReportParam();
		xrp.setName("paramName");
		xr.getReportParams().add(xrp);
		XmlReportParam xrp2 = new XmlReportParam();
		xrp2.setName("paramName");
		xr.getReportParams().add(xrp2);
		
		datas.add(xr);
		
		XmlDashboard xd = new XmlDashboard();
		xd.setName("dashName");
		xd.setReportCategoryName("catName");
		XmlDashboardColumn xdc = new XmlDashboardColumn();
		xdc.setIndex(1);
		xdc.setWidth(1);
		xd.getDashboardColumns().add(xdc);
		XmlDashboardReport xdr = new XmlDashboardReport();
		xdr.setHeight(100);
		xdr.setReportName("reportName");
		xdr.setRowIndex(1);
		xdr.setTitle("reportTitle");
		xdc.getDashboardReports().add(xdr);
		XmlDashboardParamBinding xdpb = new XmlDashboardParamBinding();
		xdpb.setDashboardParamName("dashParamName");
		xdpb.setReportParamName("reportParamName");
		xdr.getDashboardParamBindings().add(xdpb);
		XmlReportParam xdp = new XmlReportParam();
		xdp.setName("paramName");
		xd.getReportParams().add(xdp);
		
		datas.add(xd);
		
		String xml = x.toXML(datas);
		
		System.out.println(xml);
	}

}
