/**
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 *
 * You may obtain a copy of the License at 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */
package org.appspy.server.dao.xml;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

import org.apache.commons.io.IOUtils;
import org.springframework.core.io.ClassPathResource;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class XmlClasspathResourceLoader implements XmlResourceLoader
{

	/* (non-Javadoc)
	 * @see org.appspy.server.dao.xml.XmlResourceLoader#loadResource(java.lang.String)
	 */
	public byte[] loadResource(String name) throws IOException
	{
		ClassPathResource cpr = new ClassPathResource(name);
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		IOUtils.copy(cpr.getInputStream(), baos);
		
		return baos.toByteArray();
	}

}
